﻿ $(function() {
     $.fn.extend({
         customAttr: function(a, b) {
             if (b != undefined && (b != "" || typeof(b) == "boolean")) {
                 if (a == "disabled" && this.hasClass("toolbar-item")) {
                     $.each(this, function(i, item) {
                         var name = $(this).text();
                         if ($.inArray($.trim(name), parent.authMgr.getMenus()) < 0 && b == false) {} else {
                             $(this).attr(a, b);
                         }
                     });
                 } else {
                     $(this).attr(a, b);
                 }
             } else {
                 return $(this).attr(a);
             }
         }
     });
 });

/**
 * 功能：生成缓冲区对象
 * 参数：searchResult-SearchFromLocal搜索数据，key-关键字
 * 返回值：匹配的对象/null
 */
function filterByKey(searchResult, key) {
    var obj = null;
    if (searchResult.RecordCount === 0) {
        return null;
    }
    searchResult.GotoPage(0);
    for (var i = 0; i < searchResult.RecordCount; i++) {
        obj = searchResult.GetLocalObject(i);
        if (null == obj) continue;
        if (obj.GetKey() == key) {
            obj.Underground = true; // SEObjectFlagType.ObjectFlagUnderground
            return obj;
        }
    }
    return null;
};

/**
 * 将xml字符串转换为dom对象
 * @param xmlStr - xml要转换的字符串对象
 * @returns dom对象
 */
function loadXMLStr(xmlStr){
	var xmlDoc;
	
	try {
		if (window.ActiveXObject || window.ActiveXObject.prototype) {
			var activeX = ['Microsoft.XMLDOM', 'MSXML5.XMLDOM', 'MSXML.XMLDOM', 'MSXML2.XMLDOM','MSXML2.DOMDocument'];
			for (var i=0; i<activeX.length; i++){
				xmlDoc = new ActiveXObject(activeX[i]);
				xmlDoc.async = false;
				break;
			}
			if (/http/ig.test(xmlStr.substring(0,4))){
				xmlDoc.load(xmlStr);
			}else{
				xmlDoc.loadXML(xmlStr);
			}
		} else if (document.implementation && document.implementation.createDocument) {
			xmlDoc = document.implementation.createDocument('', '', null);
			xmlDoc.loadXml(xmlStr);
		} else {
			xmlDoc = null;
		}
	}catch (exception){
		xmlDoc = null;
	}
		
	return xmlDoc;
}
